using Capnp;
using Capnp.Rpc;
using System;
using System.CodeDom.Compiler;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;

namespace CapnpGen
{
    [System.CodeDom.Compiler.GeneratedCode("capnpc-csharp", "1.3.0.0"), TypeId(0x9363e93d60b35057UL)]
    public class Message : ICapnpSerializable
    {
        public const UInt64 typeId = 0x9363e93d60b35057UL;
        public enum WHICH : ushort
        {
            Greet = 0,
            Leave = 1,
            Auth = 2,
            Api = 3,
            undefined = 65535
        }

        void ICapnpSerializable.Deserialize(DeserializerState arg_)
        {
            var reader = READER.create(arg_);
            switch (reader.which)
            {
                case WHICH.Greet:
                    Greet = CapnpSerializable.Create<CapnpGen.Greeting>(reader.Greet);
                    break;
                case WHICH.Leave:
                    Leave = CapnpSerializable.Create<CapnpGen.Leave>(reader.Leave);
                    break;
                case WHICH.Auth:
                    Auth = CapnpSerializable.Create<CapnpGen.AuthMessage>(reader.Auth);
                    break;
                case WHICH.Api:
                    Api = CapnpSerializable.Create<CapnpGen.FabAccess>(reader.Api);
                    break;
            }

            applyDefaults();
        }

        private WHICH _which = WHICH.undefined;
        private object _content;
        public WHICH which
        {
            get => _which;
            set
            {
                if (value == _which)
                    return;
                _which = value;
                switch (value)
                {
                    case WHICH.Greet:
                        _content = null;
                        break;
                    case WHICH.Leave:
                        _content = null;
                        break;
                    case WHICH.Auth:
                        _content = null;
                        break;
                    case WHICH.Api:
                        _content = null;
                        break;
                }
            }
        }

        public void serialize(WRITER writer)
        {
            writer.which = which;
            switch (which)
            {
                case WHICH.Greet:
                    Greet?.serialize(writer.Greet);
                    break;
                case WHICH.Leave:
                    Leave?.serialize(writer.Leave);
                    break;
                case WHICH.Auth:
                    Auth?.serialize(writer.Auth);
                    break;
                case WHICH.Api:
                    Api?.serialize(writer.Api);
                    break;
            }
        }

        void ICapnpSerializable.Serialize(SerializerState arg_)
        {
            serialize(arg_.Rewrap<WRITER>());
        }

        public void applyDefaults()
        {
        }

        public CapnpGen.Greeting Greet
        {
            get => _which == WHICH.Greet ? (CapnpGen.Greeting)_content : null;
            set
            {
                _which = WHICH.Greet;
                _content = value;
            }
        }

        public CapnpGen.Leave Leave
        {
            get => _which == WHICH.Leave ? (CapnpGen.Leave)_content : null;
            set
            {
                _which = WHICH.Leave;
                _content = value;
            }
        }

        public CapnpGen.AuthMessage Auth
        {
            get => _which == WHICH.Auth ? (CapnpGen.AuthMessage)_content : null;
            set
            {
                _which = WHICH.Auth;
                _content = value;
            }
        }

        public CapnpGen.FabAccess Api
        {
            get => _which == WHICH.Api ? (CapnpGen.FabAccess)_content : null;
            set
            {
                _which = WHICH.Api;
                _content = value;
            }
        }

        public struct READER
        {
            readonly DeserializerState ctx;
            public READER(DeserializerState ctx)
            {
                this.ctx = ctx;
            }

            public static READER create(DeserializerState ctx) => new READER(ctx);
            public static implicit operator DeserializerState(READER reader) => reader.ctx;
            public static implicit operator READER(DeserializerState ctx) => new READER(ctx);
            public WHICH which => (WHICH)ctx.ReadDataUShort(0U, (ushort)0);
            public CapnpGen.Greeting.READER Greet => which == WHICH.Greet ? ctx.ReadStruct(0, CapnpGen.Greeting.READER.create) : default;
            public CapnpGen.Leave.READER Leave => which == WHICH.Leave ? ctx.ReadStruct(0, CapnpGen.Leave.READER.create) : default;
            public CapnpGen.AuthMessage.READER Auth => which == WHICH.Auth ? ctx.ReadStruct(0, CapnpGen.AuthMessage.READER.create) : default;
            public CapnpGen.FabAccess.READER Api => which == WHICH.Api ? ctx.ReadStruct(0, CapnpGen.FabAccess.READER.create) : default;
        }

        public class WRITER : SerializerState
        {
            public WRITER()
            {
                this.SetStruct(1, 1);
            }

            public WHICH which
            {
                get => (WHICH)this.ReadDataUShort(0U, (ushort)0);
                set => this.WriteData(0U, (ushort)value, (ushort)0);
            }

            public CapnpGen.Greeting.WRITER Greet
            {
                get => which == WHICH.Greet ? BuildPointer<CapnpGen.Greeting.WRITER>(0) : default;
                set => Link(0, value);
            }

            public CapnpGen.Leave.WRITER Leave
            {
                get => which == WHICH.Leave ? BuildPointer<CapnpGen.Leave.WRITER>(0) : default;
                set => Link(0, value);
            }

            public CapnpGen.AuthMessage.WRITER Auth
            {
                get => which == WHICH.Auth ? BuildPointer<CapnpGen.AuthMessage.WRITER>(0) : default;
                set => Link(0, value);
            }

            public CapnpGen.FabAccess.WRITER Api
            {
                get => which == WHICH.Api ? BuildPointer<CapnpGen.FabAccess.WRITER>(0) : default;
                set => Link(0, value);
            }
        }
    }

    [System.CodeDom.Compiler.GeneratedCode("capnpc-csharp", "1.3.0.0"), TypeId(0xd7c6c8a7ec8a94ffUL)]
    public class Greeting : ICapnpSerializable
    {
        public const UInt64 typeId = 0xd7c6c8a7ec8a94ffUL;
        void ICapnpSerializable.Deserialize(DeserializerState arg_)
        {
            var reader = READER.create(arg_);
            Host = reader.Host;
            Program = reader.Program;
            Major = reader.Major;
            Minor = reader.Minor;
            applyDefaults();
        }

        public void serialize(WRITER writer)
        {
            writer.Host = Host;
            writer.Program = Program;
            writer.Major = Major;
            writer.Minor = Minor;
        }

        void ICapnpSerializable.Serialize(SerializerState arg_)
        {
            serialize(arg_.Rewrap<WRITER>());
        }

        public void applyDefaults()
        {
        }

        public string Host
        {
            get;
            set;
        }

        public string Program
        {
            get;
            set;
        }

        public uint Major
        {
            get;
            set;
        }

        public uint Minor
        {
            get;
            set;
        }

        public struct READER
        {
            readonly DeserializerState ctx;
            public READER(DeserializerState ctx)
            {
                this.ctx = ctx;
            }

            public static READER create(DeserializerState ctx) => new READER(ctx);
            public static implicit operator DeserializerState(READER reader) => reader.ctx;
            public static implicit operator READER(DeserializerState ctx) => new READER(ctx);
            public string Host => ctx.ReadText(0, null);
            public string Program => ctx.ReadText(1, null);
            public uint Major => ctx.ReadDataUInt(0UL, 0U);
            public uint Minor => ctx.ReadDataUInt(32UL, 0U);
        }

        public class WRITER : SerializerState
        {
            public WRITER()
            {
                this.SetStruct(1, 2);
            }

            public string Host
            {
                get => this.ReadText(0, null);
                set => this.WriteText(0, value, null);
            }

            public string Program
            {
                get => this.ReadText(1, null);
                set => this.WriteText(1, value, null);
            }

            public uint Major
            {
                get => this.ReadDataUInt(0UL, 0U);
                set => this.WriteData(0UL, value, 0U);
            }

            public uint Minor
            {
                get => this.ReadDataUInt(32UL, 0U);
                set => this.WriteData(32UL, value, 0U);
            }
        }
    }

    [System.CodeDom.Compiler.GeneratedCode("capnpc-csharp", "1.3.0.0"), TypeId(0xc4edbaef246784cbUL)]
    public class Leave : ICapnpSerializable
    {
        public const UInt64 typeId = 0xc4edbaef246784cbUL;
        void ICapnpSerializable.Deserialize(DeserializerState arg_)
        {
            var reader = READER.create(arg_);
            TheReason = reader.TheReason;
            Message = reader.Message;
            applyDefaults();
        }

        public void serialize(WRITER writer)
        {
            writer.TheReason = TheReason;
            writer.Message = Message;
        }

        void ICapnpSerializable.Serialize(SerializerState arg_)
        {
            serialize(arg_.Rewrap<WRITER>());
        }

        public void applyDefaults()
        {
        }

        public CapnpGen.Leave.Reason TheReason
        {
            get;
            set;
        }

        public string Message
        {
            get;
            set;
        }

        public struct READER
        {
            readonly DeserializerState ctx;
            public READER(DeserializerState ctx)
            {
                this.ctx = ctx;
            }

            public static READER create(DeserializerState ctx) => new READER(ctx);
            public static implicit operator DeserializerState(READER reader) => reader.ctx;
            public static implicit operator READER(DeserializerState ctx) => new READER(ctx);
            public CapnpGen.Leave.Reason TheReason => (CapnpGen.Leave.Reason)ctx.ReadDataUShort(0UL, (ushort)0);
            public string Message => ctx.ReadText(0, null);
        }

        public class WRITER : SerializerState
        {
            public WRITER()
            {
                this.SetStruct(1, 1);
            }

            public CapnpGen.Leave.Reason TheReason
            {
                get => (CapnpGen.Leave.Reason)this.ReadDataUShort(0UL, (ushort)0);
                set => this.WriteData(0UL, (ushort)value, (ushort)0);
            }

            public string Message
            {
                get => this.ReadText(0, null);
                set => this.WriteText(0, value, null);
            }
        }

        [System.CodeDom.Compiler.GeneratedCode("capnpc-csharp", "1.3.0.0"), TypeId(0xb6e0e07e2ab5f7b2UL)]
        public enum Reason : ushort
        {
            other,
            incompatible
        }
    }
}